<INPUTLEFGENERATE 
"INPUT LEF GENERATE   

Reads LEF files containing parametric macro cells into an existing database, optionally generates the selected macros, and processes the file as a regular netlist.


Syntax

INP*UT L*EF GENERATE 
   [ [ ALL*MODELS 
     | M*ODEL macroRegExpr,... 	 	
     | C*ELL compRegExpr,... ] 	 	
     [O*UTPUT fileName] 	 	
     [CH*ECKOUTPUT 			
       [ CON*CATENATE fileName 			
       | SEP*ARATE prefix ]] ]... 	
[N*ETLIST] 	
F*ILENAME netlistFile 	
[R*EPORTFILE fileName] ;


Arguments

GENERATE
In combination with NETLIST, generates the selected macros and then processes the file as a regular netlist. Without NETLIST, only updates the library database.

ALLMODELS
Generates all parametric macros not yet processed. Default: ALLMODELS applies whenever NETLIST GENERATE is specified.

MODEL macroRegExpr,...
Generates all unprocessed parametric macros with model names that match the regular expression.

CELL compRegExpr,...
Generates all unprocessed parametric macros with component instances that match the regular expression.

OUTPUT fileName
Creates a file showing the instantiated macro cells.

CHECKOUTPUT
Records which generator and parameter values were used to instantiate each macro. CONCATENATE puts this data into a single file. SEPARATE puts the data into separate files with a common file name prefix.

NETLIST
Processes the input file as a regular netlist. Default: if neither NETLIST nor GENERATE is specified, NETLIST applies

FILENAME netlistFile
The name of the ASCII design file to read and process.

REPORTFILE fileName
The name to give the report file. Default: inpDef.rpt in the current directory


Description

INPUT LEF GENERATE reads LEF files that include parametric macro cells.

Input Files

Input data for parametric macro cells are included in LEF and DEF files. Both LEF and DEF have expanded syntaxes to handle parametric macros.

Output Files

INPUT LEF GENERATE includes options for the following types of output files that aid in testing and debugging:

- Report file 
A copy of the input file with error messages as comments. You can edit it to correct errors and then resubmit it; the LEF and DEF readers strip out comments.

- Output file 
A file showing generated macros after instantiation.

- Checkoutput files 
Files (either a single file or one per generated macro) showing the generators and parameter values used for instantiation.

- User-defined files 
Arbitrary files you can create and write to during input. Useful during debugging and production to check the validity of design parameters.

Design Flow

Use the following design flow to add parametric macro cells to the library database with INPUT LEF or INPUT DEF:

1. Create the generator macros (top-level models). 
These macros are written as alias scripts in a LEF file and are added to the library with INPUT LEF.

2. Optionally instantiate library macros.
Assign fixed values to all parameters using alias scripts in a LEF file and then running INPUT LEF GENERATE. Using INPUT LEF, you can combine this and the previous step.

3. For components particular to the design, assign fixed values to parameters.
Use alias scripts in the DEF file, then instantiate all applicable parametric macros using INPUT DEF GENERATE. 

4. Read the netlist using INPUT DEF NETLIST.
You can combine steps 3 and 4 by using INPUT DEF.


Examples

INPUT LEF GENERATE ALLMODELS 
FILENAME myDesign.nlt ;


Environmental Variables

Input.LEF.Default.XGCellSize 
INTEGER [1, 10000] - Default: 15 - NOVICE 
GCell width in tracks to use if no GCELLGRID X is specified in LEF.

Input.LEF.Default.YGCellSize 
INTEGER [1, 10000] - Default: 15 - NOVICE 
GCell height (in tracks) to use if no GCELLGRID Y is specified in LEF.

Input.LEF.Names.Case.Sensitive 
BOOLEAN - Default: false - NOVICE 
Whether INPUT LEF preserves case in names.


Related Commands

INPUT DEF reads DEF files to update a database with design-specific information.

INPUT LEF reads LEF files to create or update the library database.

INPUT GDSII creates a LEF file of selected geometric data from GDSII files.

FINPUT DEF reads DEF files to overwrite the design database with design-specific information.
"

	<Type QHELP>
	<Header "Input LEF Generate Command Help">
>
